=== debian/changelog ===
coq (8.9.0-1) unstable; urgency=high

  * New upstream release
  * Set CAML_LD_LIBRARY_PATH and COQLIB correctly during building
    (Closes: #919462)
  * Coq no longer ships an Emacs mode; users should migrate to Proof
    General (Closes: #736761, #854147, #877938)

 -- Benjamin Barenblat <bbaren@debian.org>  Wed, 06 Feb 2019 12:41:09 -0500
