=== debian/changelog ===
coq (8.9.1-5build1) focal; urgency=medium

  * No change rebuild against new ocaml ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Fri, 21 Feb 2020 23:16:34 +0000

coq (8.9.1-5) unstable; urgency=medium

  * Be more precise in install files to avoid that usr/bin/coqidetop.{opt,byte}
    gets installed in both the coq and coqide packages (closes: #949975)
  * Add an as-installed test for the compiler and the toplevel.
  * Build-Conflicts with libcoq-ocaml. This seems to be necessary to avoid
    that coq depends on two versions of libcoq-ocaml: the one being build,
    and the one that is installed on the system.

 -- Ralf Treinen <treinen@debian.org>  Tue, 28 Jan 2020 20:23:39 +0100

coq (8.9.1-4) unstable; urgency=medium

  * Patch install-coqide-bytecode: fix installation of ide on bytecode-only
    architectures.
  * Fix coqide.install for bytecode-only architectures
  * Remove coqide and coqidetop stuff from debian/not-installed

 -- Ralf Treinen <treinen@debian.org>  Mon, 27 Jan 2020 03:29:33 +0100

coq (8.9.1-3) unstable; urgency=medium

  * Reactive building of coqide (closes: #920589)
    - put back the coqide paragraph in debian/control
    - coq suggests coqide as an alternative to proofgeneral
    - mention coqide in the long description of coq
    - put back debian/coqide.{1,desktop,dirs,install,links.in} from version
      8.6-5
  * Move coqidetop from the coqide package to the coq package (closes: #946580)
  * Generate html pages for the stdlib using HTMLSTYLE=simple, to avoid
    linking to external stylesheets
  * Add lintian-overrides for filenames containing wildcard characters
    in package coq-theories
  * Build-depend on debhelper-compat, drop file debian/compat
  * Debhelper compatibility level 11
    - debian/rules: use "dh_missing --fail-missing" instead of
      "dh_install --fail-missing"
  * Standards-Version 4.5.0  (no change)

 -- Ralf Treinen <treinen@debian.org>  Fri, 24 Jan 2020 21:58:35 +0100

coq (8.9.1-2) unstable; urgency=medium

  * Recompile with OCaml 4.08.1

 -- Stéphane Glondu <glondu@debian.org>  Fri, 08 Nov 2019 16:48:46 +0100

coq (8.9.1-1) unstable; urgency=medium

  * New upstream release
  * Fix FTBFS with OCaml 4.08.0
    - add libnum-ocaml-dev to Build-Depends
    - apply a patch to fix double loading of pr_dump.cmo (camlp5)
    - remove a failing test
  * Remove Samuel from Uploaders
  * Bump Standards-Version to 4.4.0

 -- Stéphane Glondu <glondu@debian.org>  Tue, 20 Aug 2019 05:09:34 +0200
