=== debian/control ===
--- 
+++ 
@@ -1,29 +1,31 @@
 Source: coq
 Section: math
 Priority: optional
-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: Debian OCaml Maintainers <debian-ocaml-maint@lists.debian.org>
 Uploaders:
  Benjamin Barenblat <bbaren@debian.org>,
  Ralf Treinen <treinen@debian.org>,
- Samuel Mimram <smimram@debian.org>,
  Stéphane Glondu <glondu@debian.org>,
  Enrico Tassi <gareuselesinge@debian.org>
-Standards-Version: 4.3.0
+Standards-Version: 4.5.0
 Build-Depends:
- debhelper (>= 10),
+ debhelper-compat (= 11),
  dh-exec,
  dh-ocaml (>= 0.9.5~),
  dh-python,
  ocaml-nox (>= 4.02.3),
  ocaml-findlib (>= 1.4.1),
  camlp5 (>= 6.14),
- liblablgtk2-ocaml-dev (>= 2.14),
+ liblablgtk2-ocaml-dev,
  liblablgtksourceview2-ocaml-dev,
+ libnum-ocaml-dev,
  libounit-ocaml-dev,
  python3,
  rsync,
  texlive-latex-extra,
  hevea (>= 1.10-7)
+Build-Conflicts: libcoq-ocaml
 Homepage: http://coq.inria.fr/
 Vcs-Browser: https://salsa.debian.org/ocaml-team/coq
 Vcs-Git: https://salsa.debian.org/ocaml-team/coq.git
@@ -35,12 +37,12 @@
  ${ocaml:Depends},
  ${python3:Depends},
  ${shlibs:Depends},
- ${misc:Depends}, 
+ ${misc:Depends},
  ocaml-nox,
  ocaml-findlib
 Provides: coq-${F:CoqABI}
 Suggests:
- proofgeneral,
+ coqide | proofgeneral,
  ledit | readline-editor,
  libcoq-ocaml-dev,
  why (>= 2.19),
@@ -54,8 +56,25 @@
  .
  This package provides coqtop, a command line interface to Coq.
  .
- The proofgeneral package allows proofs to be edited using Emacs and
- XEmacs.
+ A graphical interface for Coq is provided in the coqide package.
+ Coq can also be used with ProofGeneral, which allows proofs to be
+ edited using emacs and xemacs. This requires the proofgeneral
+ package to be installed.
+
+Package: coqide
+Architecture: any
+Depends:
+ coq (= ${binary:Version}),
+ ${ocaml:Depends},
+ ${shlibs:Depends},
+ ${misc:Depends}
+Description: proof assistant for higher-order logic (gtk interface)
+ Coq is a proof assistant for higher-order logic, which allows the
+ development of computer programs consistent with their formal
+ specification. It is developed using Objective Caml and Camlp5.
+ .
+ This package provides CoqIde, a graphical user interface for
+ developing proofs.
 
 Package: coq-theories
 Architecture: any
