=== debian/rules ===
--- 
+++ 
@@ -22,12 +22,12 @@
 
 PACKAGES := $(shell dh_listpackages)
 
-COQ_VERSION := 8.9.0
+COQ_VERSION := 8.9.1
 COQ_ABI := $(COQ_VERSION)+$(OCAML_ABI)
 
 ARCH := $(shell dpkg-architecture -q DEB_TARGET_ARCH)
 ifeq ($(ARCH),$(filter $(ARCH),amd64 i386))
-NATIVE_COMPUTE := 
+NATIVE_COMPUTE :=
 else
 NATIVE_COMPUTE := -native-compiler no
 endif
@@ -35,7 +35,6 @@
 CONFIGUREOPTS := -arch Linux -prefix /usr -mandir /usr/share/man \
   -configdir /etc/xdg/coq \
   -browser "/usr/bin/x-www-browser %s &" \
-  -coqide no \
   -with-doc no \
   $(NATIVE_COMPUTE)
 
@@ -68,7 +67,7 @@
 # in the build system. See upstream's CHANGES.
 	$(MAKE) world STRIP=true
 	$(MAKE) byte STRIP=true
-	$(MAKE) DOC_TARGETS=$(HTMLDOC) $(HTMLDOC)
+	$(MAKE) DOC_TARGETS=$(HTMLDOC) $(HTMLDOC) HTMLSTYLE=simple
 else
 	rsync -a --exclude=debian --exclude=.git $(BUILDCACHE)/ .
 endif
@@ -89,6 +88,7 @@
 .PHONY: override_dh_auto_install
 override_dh_auto_install:
 	$(MAKE) $(ADDPREF) install install-byte
+	cp debian/coq.xpm debian/coqide/usr/share/pixmaps/coqide.xpm
 	find debian/tmp -regextype posix-awk \
 	  -regex '.*\.(cmi|cmx|cmxa|[ao])$$' \
 	  | grep -v coq-native \
@@ -102,10 +102,14 @@
 	find debian/tmp -name '.coq-native' -printf '%P\n' \
 	  >> debian/coq-theories.install
 
+.PHONY: override_dh_missing
+override_dh_missing:
+	dh_missing --fail-missing
+
 .PHONY: override_dh_install
 override_dh_install:
 	chmod +x debian/coq.install
-	dh_install --fail-missing
+	dh_install
 
 .PHONY: override_dh_fixperms
 override_dh_fixperms:
